      subroutine pol1(t,y,yp)
************************************************************************
*                                                                      *
*  Compute the right-hand sides of the Altarelli-Parisi equations      *
*  for the polarised parton densities.                                 *
*                                                                      *
*  Version of Jan 18, 2000.                                            *
*                                                                      *
************************************************************************
$include apeno.h
$include qcd.h
$include grids.h
$include gss32.h
$include speed.h
$include apesf.h
      dimension y(*), yp(*), f0(meqn), f(meqn)
************************************************************************
*     Initialise: alfs=alpha(s)/(2 pi).                                *
************************************************************************
      call spline(y)
      if (nf.eq.3) then
         bt0=bt03
         calf=bt13/bt0/bt0
         tr=tr3
         cg01=cg013
      else if (nf.eq.4) then
         bt0=bt04
         calf=bt14/bt0/bt0
         tr=tr4
         cg01=cg014
      else
         bt0=bt05
         calf=bt15/bt0/bt0
         tr=tr5
         cg01=cg015
      end if
      alfs=2*(1-calf*log(t)/t)/bt0/t
************************************************************************
*     The main control loop.                                           *
************************************************************************
      do 10 ix=1,nxgrd-1
         z0=0.5*(1+x0(ix))
         dz=0.5*(1-x0(ix))
         call splevl(x0(ix),klo(ix,0),f0)
         sigma0=f0(nq0)+f0(nu)+f0(nd)
*
         t1=0.0		! accumulators for the LO integrals
         t2=0.0
         t3=0.0
         t4=0.0
         t5=0.0
         t6=0.0
         t7=0.0
         u1=0.0		! the accumulators for the NLO integral
         u2=0.0
         u3=0.0
         u4=0.0
         u5=0.0
         u6=0.0
         u7=0.0
         do 11 ig=1,mgaus
************************************************************************
*           One of the Gauss-Legendre points.                          *
************************************************************************
            z=z0+dz*xg(ig)
            call splevl(x0(ix)/z,klo(ix,ig),f)
            do 12 i=nu,ng
 12            f(i)=f(i)/z
            sigma=f(nq0)+f(nu)+f(nd)
************************************************************************
*           The integrands to be evaluated at LO.                      *
************************************************************************
            f1p=spl1(1,ig,ix)*(f(nu)-f0(nu))
            f2p=spl1(1,ig,ix)*(f(nd)-f0(nd))
            f3p=spl1(1,ig,ix)*(f(nq0)-f0(nq0))+tr*spl1(2,ig,ix)*f(ng)
            f4p=spl1(1,ig,ix)*(f(nq3)-f0(nq3))
            f5p=spl1(1,ig,ix)*(f(nq8)-f0(nq8))
            f6p=spl1(1,ig,ix)*(f(nq15)-f0(nq15))
            f7p=spl1(5,ig,ix)*(f(ng)-f0(ng))+spl1(4,ig,ix)*f(ng)
     1         +spl1(3,ig,ix)*sigma
************************************************************************
*           The integrands to be evaluated at NLO.                     *
************************************************************************
            pplr=tr*spl2(1,ig,ix)+spl2(3,ig,ix)
            pmnr=tr*spl2(1,ig,ix)+spl2(2,ig,ix)
            psnr=tr*spl2(4,ig,ix)+spl2(2,ig,ix)
            pqqs=cf*(tr*spl2(5,ig,ix)+spl2(6,ig,ix))
            pggs=ca*(tr*spl2(5,ig,ix)+spl2(6,ig,ix))
            pqgr=tr*spl2(7,ig,ix)
            pqgs=tr*spl2(8,ig,ix)
            pgqr=tr*spl2(9,ig,ix)+spl2(10,ig,ix)
            pgqs=tr*spl2(11,ig,ix)+spl2(12,ig,ix)
            pggr=tr*spl2(13,ig,ix)+spl2(14,ig,ix)
*
            g1p=pplr*f(nu)+pqqs*(f(nu)-f0(nu))
            g2p=pplr*f(nd)+pqqs*(f(nd)-f0(nd))
            sub0=(pmnr-pplr)*(f(nu)+f(nd))
            sub3=(pmnr-pplr)*(f(nu)-f(nd))
            g3qk=psnr*sigma-pplr*(f(nu)+f(nd))+pqqs*(f(nq0)-f0(nq0))
            g3gl=pqgr*f(ng)+pqgs*(f(ng)-f0(ng))
            g3p=g3qk+g3gl
            g4p=pmnr*f(nq3)+sub3+pqqs*(f(nq3)-f0(nq3))
            g5p=pmnr*f(nq8)+sub0+pqqs*(f(nq8)-f0(nq8))
            g6p=pmnr*f(nq15)+sub0+pqqs*(f(nq15)-f0(nq15))
            g7qk=pgqr*sigma+pgqs*(sigma-sigma0)
            g7gl=pggr*f(ng)+pggs*(f(ng)-f0(ng))
            g7p=g7qk+g7gl
************************************************************************
*           Another of the Gauss-Legendre points.                      *
************************************************************************
            z=z0-dz*xg(ig)
            call splevl(x0(ix)/z,klo(ix,mgaus+ig),f)
            do 15 i=nu,ng
 15            f(i)=f(i)/z
            sigma=f(nq0)+f(nu)+f(nd)
************************************************************************
*           The integrands to be evaluated at LO.                      *
************************************************************************
            f1m=spl1(1,mgaus+ig,ix)*(f(nu)-f0(nu))
            f2m=spl1(1,mgaus+ig,ix)*(f(nd)-f0(nd))
            f3m=spl1(1,mgaus+ig,ix)*(f(nq0)-f0(nq0))
     1         +tr*spl1(2,mgaus+ig,ix)*f(ng)
            f4m=spl1(1,mgaus+ig,ix)*(f(nq3)-f0(nq3))
            f5m=spl1(1,mgaus+ig,ix)*(f(nq8)-f0(nq8))
            f6m=spl1(1,mgaus+ig,ix)*(f(nq15)-f0(nq15))
            f7m=spl1(5,mgaus+ig,ix)*(f(ng)-f0(ng))
     1         +spl1(4,mgaus+ig,ix)*f(ng)+spl1(3,mgaus+ig,ix)*sigma
************************************************************************
*           The integrands to be evaluated at NLO.                     *
************************************************************************
            pplr=tr*spl2(1,mgaus+ig,ix)+spl2(3,mgaus+ig,ix)
            pmnr=tr*spl2(1,mgaus+ig,ix)+spl2(2,mgaus+ig,ix)
            psnr=tr*spl2(4,mgaus+ig,ix)+spl2(2,mgaus+ig,ix)
            pqqs=cf*(tr*spl2(5,mgaus+ig,ix)+spl2(6,mgaus+ig,ix))
            pggs=ca*(tr*spl2(5,mgaus+ig,ix)+spl2(6,mgaus+ig,ix))
            pqgr=tr*spl2(7,mgaus+ig,ix)
            pqgs=tr*spl2(8,mgaus+ig,ix)
            pgqr=tr*spl2(9,mgaus+ig,ix)+spl2(10,mgaus+ig,ix)
            pgqs=tr*spl2(11,mgaus+ig,ix)+spl2(12,mgaus+ig,ix)
            pggr=tr*spl2(13,mgaus+ig,ix)+spl2(14,mgaus+ig,ix)
*
            g1m=pplr*f(nu)+pqqs*(f(nu)-f0(nu))
            g2m=pplr*f(nd)+pqqs*(f(nd)-f0(nd))
            sub0=(pmnr-pplr)*(f(nu)+f(nd))
            sub3=(pmnr-pplr)*(f(nu)-f(nd))
            g3qk=psnr*sigma-pplr*(f(nu)+f(nd))+pqqs*(f(nq0)-f0(nq0))
            g3gl=pqgr*f(ng)+pqgs*(f(ng)-f0(ng))
            g3m=g3qk+g3gl
            g4m=pmnr*f(nq3)+sub3+pqqs*(f(nq3)-f0(nq3))
            g5m=pmnr*f(nq8)+sub0+pqqs*(f(nq8)-f0(nq8))
            g6m=pmnr*f(nq15)+sub0+pqqs*(f(nq15)-f0(nq15))
            g7qk=pgqr*sigma+pgqs*(sigma-sigma0)
            g7gl=pggr*f(ng)+pggs*(f(ng)-f0(ng))
            g7m=g7qk+g7gl
************************************************************************
*           The accumulators are updated.                              *
************************************************************************
            t1=t1+wg(ig)*(f1p+f1m)
            t2=t2+wg(ig)*(f2p+f2m)
            t3=t3+wg(ig)*(f3p+f3m)
            t4=t4+wg(ig)*(f4p+f4m)
            t5=t5+wg(ig)*(f5p+f5m)
            t6=t6+wg(ig)*(f6p+f6m)
            t7=t7+wg(ig)*(f7p+f7m)
            u1=u1+wg(ig)*(g1p+g1m)
            u2=u2+wg(ig)*(g2p+g2m)
            u3=u3+wg(ig)*(g3p+g3m)
            u4=u4+wg(ig)*(g4p+g4m)
            u5=u5+wg(ig)*(g5p+g5m)
            u6=u6+wg(ig)*(g6p+g6m)
            u7=u7+wg(ig)*(g7p+g7m)
 11         continue
************************************************************************
*        The compensatory parts are computed.                          *
************************************************************************
         qx0=alfs*cf*(x0(ix)*(1+0.5*x0(ix))+2*xl(ix))
         gx0=alfs*(cg01+cg02*xl(ix))
         qx1=alfs*alfs*cf*(-tr*(cpf0+20*xl(ix)/9)+cf*cpff0
     1                     +ca*(cpaf0+cpaf1*xl(ix)))
         gx1=-alfs*alfs*(cf*tr+ca*tr*(4/3.+20*xl(ix)/9)
     1                  -ca*ca*(cpaa0+cpaf1*xl(ix)))
         qg1=2*alfs*alfs*tr*(cf-ca)*(1-x0(ix))*(2+xl(ix)*(-2+xl(ix)))
         gq1=alfs*alfs*cf*(1-x0(ix))*(tr*4*(1-xl(ix))/3.
     1                               +cf*(1-xl(ix)*(1+xl(ix)))
     2                               -ca*(5-xl(ix)*(5+3*xl(ix)))/3.)
************************************************************************
*        The result is computed.                                       *
************************************************************************
         dx=alfs*dz
         yp(ix+m1u*nxgrd)  =(qx0+qx1)*f0(nu)+dx*(t1+alfs*u1)
         yp(ix+m1d*nxgrd)  =(qx0+qx1)*f0(nd)+dx*(t2+alfs*u2)
         yp(ix+m1q0*nxgrd) =(qx0+qx1)*f0(nq0)+qg1*f0(ng)+dx*(t3+alfs*u3)
         yp(ix+m1q3*nxgrd) =(qx0+qx1)*f0(nq3)+dx*(t4+alfs*u4)
         yp(ix+m1q8*nxgrd) =(qx0+qx1)*f0(nq8)+dx*(t5+alfs*u5)
         yp(ix+m1q15*nxgrd)=(qx0+qx1)*f0(nq15)+dx*(t6+alfs*u6)
10       yp(ix+m1g*nxgrd)  =(gx0+gx1)*f0(ng)+gq1*sigma0+dx*(t7+alfs*u7)
*
      do 16 i=1,meqn
 16      yp(i*nxgrd)=0.
*
      return
      end
      subroutine unpol1(t,y,yp)
************************************************************************
*                                                                      *
*  Compute the right-hand sides of the Altarelli-Parisi equations      *
*  for the unpolarised parton densities.                               *
*                                                                      *
*  Version of Jan 18, 2000.                                            *
*                                                                      *
************************************************************************
$include apeno.h
$include qcd.h
$include grids.h
$include gss32.h
$include speed.h
$include apesf.h
      dimension y(*), yp(*), f0(meqn), f(meqn)
************************************************************************
*     Initialise: alfs=alpha(s)/(2 pi).                                *
************************************************************************
      call spline(y)
      if (nf.eq.3) then
         bt0=bt03
         calf=bt13/bt0/bt0
         tr=tr3
         cg01=cg013
      else if (nf.eq.4) then
         bt0=bt04
         calf=bt14/bt0/bt0
         tr=tr4
         cg01=cg014
      else
         bt0=bt05
         calf=bt15/bt0/bt0
         tr=tr5
         cg01=cg015
      end if
      alfs=2*(1-calf*log(t)/t)/bt0/t
************************************************************************
*     The main control loop.                                           *
************************************************************************
      do 10 ix=1,nxgrd-1
         z0=0.5*(1+x0(ix))
         dz=0.5*(1-x0(ix))
         call splevl(x0(ix),klo(ix,0),f0)
         sigma0=f0(nq0)+f0(nu)+f0(nd) ! need q3, q8, q15 and q24 also
*
         t1=0.0
         t2=0.0
         t3=0.0
         t4=0.0
         t5=0.0
         t6=0.0
         t7=0.0
         u1=0.0		! the accumulators for the NLO integral
         u2=0.0
         u3=0.0
         u4=0.0
         u5=0.0
         u6=0.0
         u7=0.0
         do 11 ig=1,mgaus
************************************************************************
*           One of the Gauss-Legendre points.                          *
************************************************************************
            z=z0+dz*xg(ig)
            z2=z*z
            z2p1=1+z2
            zm1=1-z
            z2m1=1-2*z
            zm2=(1-z)*(1-z)
            zln=log(z)
            zl1=log(1-z)
            s22=zln*(zln-4*log(1+z))-2*zeta2-4*dilog(-z)
            call splevl(x0(ix)/z,klo(ix,ig),f)
            do 17 i=nu,ng 
 17            f(i)=f(i)/z
            sigma=f(nq0)+f(nu)+f(nd)
************************************************************************
*           The integrands to be evaluated at LO.                      *
************************************************************************
            f1p=spl1(1,ig,ix)*(f(nu)-f0(nu))
            f2p=spl1(1,ig,ix)*(f(nd)-f0(nd))
            f3p=spl1(1,ig,ix)*(f(nq0)-f0(nq0))
     1         +2*tr*(1-2*z*zm1)*f(ng)
            f4p=spl1(1,ig,ix)*(f(nq3)-f0(nq3))
            f5p=spl1(1,ig,ix)*(f(nq8)-f0(nq8))
            f6p=spl1(1,ig,ix)*(f(nq15)-f0(nq15))
            f7p=spl1(5,ig,ix)*(f(ng)-f0(ng))
     1         +cg02*zm1*z2p1*f(ng)/z+cf*(1+zm2)*sigma/z
************************************************************************
*           The integrands to be evaluated at NLO.                     *
************************************************************************
            pplr=tr*spl2(1,ig,ix)+spl2(3,ig,ix)
            pmnr=tr*spl2(1,ig,ix)+spl2(2,ig,ix)
            psnr=cf*tr*(2*(65*z-19)/9.+zln*(4*(2+8*z+4*z2-1/zm1)/3
     1            -2*zln*(1+z))-8*(14*z2-5/z)/9.)+spl2(3,ig,ix)
            pqqs=cf*(tr*spl2(5,ig,ix)+spl2(6,ig,ix))
            pggs=ca*(tr*spl2(5,ig,ix)+spl2(6,ig,ix))
            pqgr=tr*(cf*(4-9*z-zln*(1-4*z+z2m1*zln)+4*z*zm1*zl1*(
     1            2-zl1)+(10-4*zeta2+2*zln*(zln+2)-4*zln*zl1)*(z2+zm2))
     2            + ca*((20/z+91+7*z)*2/9.-2*zln*((19-68*z)/3.+(1+4*z)
     3            *zln)-4*z*zm1*zl1*(2-zl1)+s22*(1+2*z*(1+z))
     4           +(cpaf2+zln*(44/3.-zln))*(1-2*z*zm1)))
            pqgs=tr*spl2(8,ig,ix)
            pgqr=cf*((-8*tr*(5*zm1/3./z+4*z/3.+zm1*zl1/z)/3.+
     1            cf*(-(5+7*z)+(4+7*z)*zln-(2-z)*zln*zln-4*zm1*zl1*
     2		      (3+zl1)/z)/2.+
     3		  ca*((28+65*z/2.+44*z2)/9.+zln*(-(12+5*z+8*z2/3.)+zln*
     4		      (4+z))+2*zm1*zl1/z*(11/3.+zl1)-s22*(z/2.+(1+z)/z)
     5		     +(0.5-zeta2+zln*(zln/2.-2*zl1))*(z+2*zm1/z))))
            pgqs=cf*zl1*(tr*(-4/3.)-cf*(5+zl1)+ca*(17/3.+zl1))
            pggr=cf*tr*(-8*(2-z)+4*(5*z2+1/z)/3.
     1                               -zln*2*(3+5*z+(1+z)*zln))
     2		+2*ca*tr*(zm1+13*(z2-1/z)/9.-2*(1+z)*zln/3.
     3                               -10*(1/z-2+z-z2)/9.)
     4          +ca*ca*(27*zm1/2.+67*(z2-1/z)/9.+zln*(
     5               -(25-11*z+44*z2)/3.+4*(1+z)*zln)+s22*
     6                (1/(1+z)-1/z-2-z-z2)+(cpaf1+zln*(zln-4*zl1))*
     7                (1/z-2+z-z2)+zln*(zln-4*zl1)/zm1)
*
            g1p=pmnr*f(nu)+pqqs*(f(nu)-f0(nu))
            g2p=pmnr*f(nd)+pqqs*(f(nd)-f0(nd))
	    sub0=(pplr-pmnr)*(f(nu)+f(nd))
	    sub3=(pplr-pmnr)*(f(nu)-f(nd))
            g3qk=psnr*sigma-pmnr*(f(nu)+f(nd))+pqqs*(f(nq0)-f0(nq0))
            g3gl=pqgr*f(ng)+pqgs*(f(ng)-f0(ng))
            g3p=g3qk+g3gl
            g4p=pplr*f(nq3)+sub3+pqqs*(f(nq3)-f0(nq3))
            g5p=pplr*f(nq8)+sub0+pqqs*(f(nq8)-f0(nq8))
            g6p=pplr*f(nq15)+sub0+pqqs*(f(nq15)-f0(nq15))
            g7qk=pgqr*sigma+pgqs*(sigma-sigma0)
      	    g7gl=pggr*f(ng)+pggs*(f(ng)-f0(ng))
            g7p=g7qk+g7gl
************************************************************************
*           Another of the Gauss-Legendre points.                      *
************************************************************************
            z=z0-dz*xg(ig)
            z2=z*z
            z2p1=1+z2
            zm1=1-z
            z2m1=1-2*z
            zm2=(1-z)*(1-z)
            zln=log(z)
            zl1=log(1-z)
            s22=zln*(zln-4*log(1+z))-2*zeta2-4*dilog(-z)
            call splevl(x0(ix)/z,klo(ix,mgaus+ig),f)
            do 18 i=nu,ng
 18            f(i)=f(i)/z
            sigma=f(nq0)+f(nu)+f(nd)
************************************************************************
*           The integrands to be evaluated at LO.                      *
************************************************************************
            f1m=spl1(1,mgaus+ig,ix)*(f(nu)-f0(nu))
            f2m=spl1(1,mgaus+ig,ix)*(f(nd)-f0(nd))
            f3m=spl1(1,mgaus+ig,ix)*(f(nq0)-f0(nq0))
     1         +2*tr*(1-2*z*zm1)*f(ng)
            f4m=spl1(1,mgaus+ig,ix)*(f(nq3)-f0(nq3))
            f5m=spl1(1,mgaus+ig,ix)*(f(nq8)-f0(nq8))
            f6m=spl1(1,mgaus+ig,ix)*(f(nq15)-f0(nq15))
            f7m=spl1(5,mgaus+ig,ix)*(f(ng)-f0(ng))
     1         +cg02*zm1*z2p1*f(ng)/z+cf*(1+zm2)*sigma/z
************************************************************************
*           The integrands to be evaluated at NLO.                     *
************************************************************************
            pplr=tr*spl2(1,mgaus+ig,ix)+spl2(3,mgaus+ig,ix)
            pmnr=tr*spl2(1,mgaus+ig,ix)+spl2(2,mgaus+ig,ix)
            psnr=cf*tr*(2*(65*z-19)/9.+zln*(4*(2+8*z+4*z2-1/zm1)/3
     1            -2*zln*(1+z))-8*(14*z2-5/z)/9.)+spl2(3,mgaus+ig,ix)
            pqqs=cf*(tr*spl2(5,mgaus+ig,ix)+spl2(6,mgaus+ig,ix))
            pggs=ca*(tr*spl2(5,mgaus+ig,ix)+spl2(6,mgaus+ig,ix))
            pqgr=tr*(cf*(4-9*z-zln*(1-4*z+z2m1*zln)+4*z*zm1*zl1*(
     1            2-zl1)+(10-4*zeta2+2*zln*(zln+2)-4*zln*zl1)*(z2+zm2))
     2            + ca*((20/z+91+7*z)*2/9.-2*zln*((19-68*z)/3.+(1+4*z)
     3            *zln)-4*z*zm1*zl1*(2-zl1)+s22*(1+2*z*(1+z))
     4           +(cpaf2+zln*(44/3.-zln))*(1-2*z*zm1)))
            pqgs=tr*spl2(8,mgaus+ig,ix)
            pgqr=cf*((-8*tr*(5*zm1/3./z+4*z/3.+zm1*zl1/z)/3.+
     1            cf*(-(5+7*z)+(4+7*z)*zln-(2-z)*zln*zln-4*zm1*zl1*
     2		      (3+zl1)/z)/2.+
     3		  ca*((28+65*z/2.+44*z2)/9.+zln*(-(12+5*z+8*z2/3.)+zln*
     4		      (4+z))+2*zm1*zl1/z*(11/3.+zl1)-s22*(z/2.+(1+z)/z)
     5		     +(0.5-zeta2+zln*(zln/2.-2*zl1))*(z+2*zm1/z))))
            pgqs=cf*zl1*(tr*(-4/3.)-cf*(5+zl1)+ca*(17/3.+zl1))
            pggr=cf*tr*(-8*(2-z)+4*(5*z2+1/z)/3.
     1                               -zln*2*(3+5*z+(1+z)*zln))
     2		+2*ca*tr*(zm1+13*(z2-1/z)/9.-2*(1+z)*zln/3.
     3                               -10*(1/z-2+z-z2)/9.)
     4          +ca*ca*(27*zm1/2.+67*(z2-1/z)/9.+zln*(
     5               -(25-11*z+44*z2)/3.+4*(1+z)*zln)+s22*
     6                (1/(1+z)-1/z-2-z-z2)+(cpaf1+zln*(zln-4*zl1))*
     7                (1/z-2+z-z2)+zln*(zln-4*zl1)/zm1)
*
            g1m=pmnr*f(nu)+pqqs*(f(nu)-f0(nu))
            g2m=pmnr*f(nd)+pqqs*(f(nd)-f0(nd))
	    sub0=(pplr-pmnr)*(f(nu)+f(nd))
	    sub3=(pplr-pmnr)*(f(nu)-f(nd))
            g3qk=psnr*sigma-pmnr*(f(nu)+f(nd))+pqqs*(f(nq0)-f0(nq0))
            g3gl=pqgr*f(ng)+pqgs*(f(ng)-f0(ng))
            g3m=g3qk+g3gl
            g4m=pplr*f(nq3)+sub3+pqqs*(f(nq3)-f0(nq3))
            g5m=pplr*f(nq8)+sub0+pqqs*(f(nq8)-f0(nq8))
            g6m=pplr*f(nq15)+sub0+pqqs*(f(nq15)-f0(nq15))
            g7qk=pgqr*sigma+pgqs*(sigma-sigma0)
      	    g7gl=pggr*f(ng)+pggs*(f(ng)-f0(ng))
            g7m=g7qk+g7gl
************************************************************************
*           The accumulators are updated.                              *
************************************************************************
            t1=t1+wg(ig)*(f1p+f1m)
            t2=t2+wg(ig)*(f2p+f2m)
            t3=t3+wg(ig)*(f3p+f3m)
            t4=t4+wg(ig)*(f4p+f4m)
            t5=t5+wg(ig)*(f5p+f5m)
            t6=t6+wg(ig)*(f6p+f6m)
            t7=t7+wg(ig)*(f7p+f7m)
            u1=u1+wg(ig)*(g1p+g1m)
            u2=u2+wg(ig)*(g2p+g2m)
            u3=u3+wg(ig)*(g3p+g3m)
            u4=u4+wg(ig)*(g4p+g4m)
            u5=u5+wg(ig)*(g5p+g5m)
            u6=u6+wg(ig)*(g6p+g6m)
            u7=u7+wg(ig)*(g7p+g7m)
 11         continue
************************************************************************
*        The compensatory parts are computed.                          *
************************************************************************
         qx0=alfs*cf*(x0(ix)*(1+0.5*x0(ix))+2*xl(ix))
         gx0=alfs*(cg01+cg02*xl(ix))
         qx1=alfs*alfs*cf*(-tr*(cpf0+20*xl(ix)/9)+cf*cpff0
     1                     +ca*(cpaf0+cpaf1*xl(ix)))
         gx1=-alfs*alfs*(cf*tr+ca*tr*(4/3.+20*xl(ix)/9)
     1                  -ca*ca*(cpaa0+cpaf1*xl(ix)))
         qg1=2*alfs*alfs*tr*(cf-ca)*(1-x0(ix))*(2+xl(ix)*(-2+xl(ix)))
         gq1=alfs*alfs*cf*(1-x0(ix))*(tr*4*(1-xl(ix))/3.
     1                               +cf*(3-xl(ix)*(3+xl(ix)))
     2                               -ca*(11-xl(ix)*(11+3*xl(ix)))/3.)
************************************************************************
*        The result is computed.                                       *
************************************************************************
         dx=alfs*dz
         yp(ix+m1u*nxgrd)  =(qx0+qx1)*f0(nu)+dx*(t1+alfs*u1)
         yp(ix+m1d*nxgrd)  =(qx0+qx1)*f0(nd)+dx*(t2+alfs*u2)
         yp(ix+m1q0*nxgrd) =(qx0+qx1)*f0(nq0)+qg1*f0(ng)+dx*(t3+alfs*u3)
         yp(ix+m1q3*nxgrd) =(qx0+qx1)*f0(nq3)+dx*(t4+alfs*u4)
         yp(ix+m1q8*nxgrd) =(qx0+qx1)*f0(nq8)+dx*(t5+alfs*u5)
         yp(ix+m1q15*nxgrd)=(qx0+qx1)*f0(nq15)+dx*(t6+alfs*u6)
 10      yp(ix+m1g*nxgrd)  =(gx0+gx1)*f0(ng)+gq1*sigma0+dx*(t7+alfs*u7)
*
      do 19 i=1,meqn
 19      yp(i*nxgrd)=0.
*
      return
      end

