      function f1(iq,ix,kode)
************************************************************************
*                                                                      *
*     Compute F1(x,Q^2) at NLO.                                        *
*     Version of January 19, 2000.                                     *
*                                                                      *
************************************************************************
$include apeno.h
$include grids.h
$include datacom.h
$include gss32.h
$include dsped.h
$include speed.h
$include qcd.h
      dimension g(meqn), g0(meqn)
************************************************************************
*                                                                      *
*     Initialise constants, and Alpha_s/2 Pi ( called alfs).           *
*                                                                      *
************************************************************************
      if (neff(iq).eq.3) then
         bt0=bt03
         calf=bt13/bt0/bt0
         chsq=ch3
      else if (neff(iq).eq.4) then
         bt0=bt04
         calf=bt14/bt0/bt0
         chsq=ch4
      else
         bt0=bt05
         calf=bt15/bt0/bt0
         chsq=ch5
      end if
      alfs=2*(1-calf*log(q2(iq))/q2(iq))/bt0/q2(iq)
************************************************************************
*                                                                      *
*     Initialise parton densities and lowest order F1.                 *
*                                                                      *
************************************************************************
      call splevl(xd(ix),klod(ix,0),g0)
      if (kode.eq.kprot) then
         f10=(4*g0(nu)+g0(nd)+2.5*g0(nq0)+1.5*g0(nq3)+
     1          0.5*g0(nq8)-0.5*g0(nq15))/18.
      else if (kode.eq.kdeut) then
         f10=(2.5*g0(nu)+2.5*g0(nd)+2.5*g0(nq0)+
     1          0.5*g0(nq8)-0.5*g0(nq15))/18.
      else if (kode.eq.kneut) then
         f10=(g0(nu)+4*g0(nd)+2.5*g0(nq0)-1.5*g0(nq3)+
     1          0.5*g0(nq8)-0.5*g0(nq15))/18.
      end if
************************************************************************
*                                                                      *
*     Perform the convolution with the coefficient functions.          *
*                                                                      *
************************************************************************
      dz=0.5*(1-xd(ix))
      z0=0.5*(1+xd(ix))
      totq=0.
      totg=0.
*
      do 20 ig=1,mgaus
************************************************************************
*        One of the Gauss-Legendre points.                             *
************************************************************************
         z=z0+dz*xg(ig)
         zm1=1-z
         zl1=log(zm1)
         zlg=log(z)
         rgq=3+(1+z-2/zm1)*zlg+zm1*zl1
         sgq=2*zl1/zm1-1.5/zm1-2*zl1
	 rgg=-2*z*zm1*(zl1-zlg)-1+4*z*zm1-zlg
	 sgg=zl1
*
         call splevl(xd(ix)/z,klod(ix,ig),g)
         if (kode.eq.kprot) then
            sfn=(4*g(nu)+g(nd)+2.5*g(nq0)+1.5*g(nq3)+
     1             0.5*(g(nq8)-g(nq15)))/18.
         else if (kode.eq.kdeut) then
            sfn=(2.5*g(nu)+2.5*g(nd)+2.5*g(nq0)+
     1             0.5*(g(nq8)-g(nq15)))/18.
         else if (kode.eq.kneut) then
            sfn=(g(nu)+4*g(nd)+2.5*g(nq0)-1.5*g(nq3)+
     1             0.5*(g(nq8)-g(nq15)))/18.
         end if
         fp1=rgq*sfn/z+sgq*(sfn/z-f10)
         fp7=rgg*g(ng)/z+sgg*(g(ng)/z-g0(ng))
************************************************************************
*        The other Gauss-Legendre points.                              *
************************************************************************
         z=z0-dz*xg(ig)
         zm1=1-z
         zl1=log(zm1)
         zlg=log(z)
         rgq=3+(1+z-2/zm1)*zlg+zm1*zl1
         sgq=2*zl1/zm1-1.5/zm1-2*zl1
	 rgg=-2*z*zm1*(zl1-zlg)-1+4*z*zm1-zlg
	 sgg=zl1
*
         call splevl(xd(ix)/z,klod(ix,mgaus+ig),g)
         if (kode.eq.kprot) then
            sfn=(4*g(nu)+g(nd)+2.5*g(nq0)+1.5*g(nq3)+
     1             0.5*(g(nq8)-g(nq15)))/18.
         else if (kode.eq.kdeut) then
            sfn=(2.5*g(nu)+2.5*g(nd)+2.5*g(nq0)+
     1             0.5*(g(nq8)-g(nq15)))/18.
         else if (kode.eq.kneut) then
            sfn=(g(nu)+4*g(nd)+2.5*g(nq0)-1.5*g(nq3)+
     1             0.5*(g(nq8)-g(nq15)))/18.
         end if
         fm1=rgq*sfn/z+sgq*(sfn/z-f10)
         fm7=rgg*g(ng)/z+sgg*(g(ng)/z-g0(ng))
************************************************************************
*        Update the accumulators.                                      *
************************************************************************
         totq=totq+wg(ig)*(fp1+fm1)
         totg=totg+wg(ig)*(fp7+fm7)
 20      continue
************************************************************************
*                                                                      *
*     Add the compensatory parts and compute F1.                       *
*                                                                      *
************************************************************************
      cq=cf1q+2*xd(ix)+xld(ix)*(3.5-2*xd(ix)-xld(ix))
      cogg=chsq*(1-xd(ix))*(xld(ix)-1)
      f1=f10+alfs*(dz*(cf*totq+chsq*totg)-cf*cq*f10+cogg*g0(ng))
*
      return
      end
      function g1(iq,ix,kode)
************************************************************************
*                                                                      *
*     Compute G1(x,Q^2) at NLO.                                        *
*     Version of January 20, 2000.                                     *
*                                                                      *
************************************************************************
$include apeno.h
$include grids.h
$include datacom.h
$include gss32.h
$include dsped.h
$include speed.h
$include qcd.h
      dimension g(meqn), g0(meqn)
************************************************************************
*                                                                      *
*     Initialise constants, and Alpha_s/2 Pi ( called alfs).           *
*                                                                      *
************************************************************************
      if (neff(iq).eq.3) then
         bt0=bt03
         calf=bt13/bt0/bt0
         chsq=ch3
      else if (neff(iq).eq.4) then
         bt0=bt04
         calf=bt14/bt0/bt0
         chsq=ch4
      else
         bt0=bt05
         calf=bt15/bt0/bt0
         chsq=ch5
      end if
      alfs=2*(1-calf*log(q2(iq))/q2(iq))/bt0/q2(iq)
************************************************************************
*                                                                      *
*     Initialise parton densities and lowest order g1.                 *
*                                                                      *
************************************************************************
      call splevl(xd(ix),klod(ix,0),g0)
      if (kode.eq.kprot) then
         g10=(4*g0(nu)+g0(nd)+2.5*g0(nq0)+1.5*g0(nq3)+
     1          0.5*(g0(nq8)-g0(nq15)))/18.
      else if (kode.eq.kdeut) then
         g10=(2.5*g0(nu)+2.5*g0(nd)+2.5*g0(nq0)+
     1          0.5*(g0(nq8)-g0(nq15)))/18.
      else if (kode.eq.kneut) then
         g10=(g0(nu)+4*g0(nd)+2.5*g0(nq0)-1.5*g0(nq3)+
     1          0.5*(g0(nq8)-g0(nq15)))/18.
      end if
************************************************************************
*                                                                      *
*     Perform the convolution with the coefficient functions.          *
*                                                                      *
************************************************************************
      dz=0.5*(1-xd(ix))
      z0=0.5*(1+xd(ix))
      totq=0.
      totg=0.
*
      do 20 ig=1,mgaus
************************************************************************
*        One of the Gauss-Legendre points.                             *
************************************************************************
         z=z0+dz*xg(ig)
         zm1=1-z
         zl1=log(zm1)
         zlg=log(z)
         rgq=2+z+(1+z-2/zm1)*zlg+zm1*zl1
         sgq=2*zl1/zm1-1.5/zm1-2*zl1
         rgg=3-4*z+(1-2*z)*zlg-2*zm1*zl1
         sgg=zl1
*
         call splevl(xd(ix)/z,klod(ix,ig),g)
         if (kode.eq.kprot) then
            sfn=(4*g(nu)+g(nd)+2.5*g(nq0)+1.5*g(nq3)+
     1             0.5*(g(nq8)-g(nq15)))/18.
         else if (kode.eq.kdeut) then
            sfn=(2.5*g(nu)+2.5*g(nd)+2.5*g(nq0)+
     1             0.5*(g(nq8)-g(nq15)))/18.
         else if (kode.eq.kneut) then
            sfn=(g(nu)+4*g(nd)+2.5*g(nq0)-1.5*g(nq3)+
     1             0.5*(g(nq8)-g(nq15)))/18.
         end if
         fp1=rgq*sfn/z+sgq*(sfn/z-g10)
         fp7=rgg*g(ng)/z+sgg*(g(ng)/z-g0(ng))
************************************************************************
*        The other Gauss-Legendre points.                              *
************************************************************************
         z=z0-dz*xg(ig)
         zm1=1-z
         zl1=log(zm1)
         zlg=log(z)
         rgq=2+z+(1+z-2/zm1)*zlg+zm1*zl1
         sgq=2*zl1/zm1-1.5/zm1-2*zl1
         rgg=3-4*z+(1-2*z)*zlg-2*zm1*zl1
         sgg=zl1
*
         call splevl(xd(ix)/z,klod(ix,mgaus+ig),g)
         if (kode.eq.kprot) then
            sfn=(4*g(nu)+g(nd)+2.5*g(nq0)+1.5*g(nq3)+
     1             0.5*(g(nq8)-g(nq15)))/18.
         else if (kode.eq.kdeut) then
            sfn=(2.5*g(nu)+2.5*g(nd)+2.5*g(nq0)+
     1             0.5*(g(nq8)-g(nq15)))/18.
         else if (kode.eq.kneut) then
            sfn=(g(nu)+4*g(nd)+2.5*g(nq0)-1.5*g(nq3)+
     1             0.5*(g(nq8)-g(nq15)))/18.
         end if
         fm1=rgq*sfn/z+sgq*(sfn/z-g10)
         fm7=rgg*g(ng)/z+sgg*(g(ng)/z-g0(ng))
************************************************************************
*        Update the accumulators.                                      *
************************************************************************
         totq=totq+wg(ig)*(fp1+fm1)
         totg=totg+wg(ig)*(fp7+fm7)
 20      continue
************************************************************************
*                                                                      *
*     Add the compensatory parts and compute g1.                       *
*                                                                      *
************************************************************************
      cq=cg1q-2*(1-xd(ix))+xld(ix)*(3.5-2*xd(ix)-xld(ix))	
      cogg=(1-xd(ix))*(xld(ix)-1)
      g1=g10+alfs*(dz*(cf*totq+chsq*totg)-cf*cq*g10+chsq*cogg*g0(ng))
*
      return
      end
